#define	PORT_ID	80		// HTTP port

#define	ROOT_DIR	"d:\\_ftp\\www"
#define	DEFLT_FILE	"index.htm"

//#define		DATASIZE	32
//#define		DATASIZE	1400
//#define		DATASIZE		4095
//#define		DATASIZE		0xEFFC
#define		DATASIZE		1000

//#define		FILE_RD			"tst_r.txt"
#define		FILE_RD			"index.htm"

#include <stdio.h>      // for printf(), fprintf()
#include <winsock.h>    // for socket(),...
#include <stdlib.h>     // for exit()

#define MAXPENDING 5    // Maximum outstanding connection requests

void DieWithError(char *errMsg)
{
    fprintf(stderr,"%s: %d\n", errMsg, WSAGetLastError());
    exit(1);
}


//void DieWithError(char *errMsg);  // Error handling function

//void main(int argc, char *argv[])
void main(void)
{
    int 		servSock;         	// Socket descriptor for server
    int 		clntSock;        	// Socket descriptor for client
    SOCKADDR_IN servAddr; 			// Local address
    SOCKADDR_IN echoClntAddr; 		// Client address
    unsigned 	clntLen;            // Length of client address data structure
    WSADATA 	wsaData;       		// Structure for WinSock setup communication

    char 	szBuf[DATASIZE+1];   	// Buffer for echo string
    int 	lenBuf;              	// Size of received message
	FILE	*pFile;

	char 	*pCh, *pFileBuf;
	long 	fileSize;
	char 	filename[100];
	int 	i, fileExt;
	char 	buf[100];

    if (WSAStartup(MAKEWORD(2, 0), &wsaData) != 0) // Load Winsock 2.0 DLL
    {
        fprintf(stderr, "WSAStartup() failed");
        exit(1);
    }

    // Construct local address structure
    memset(&servAddr, 0, sizeof(servAddr));   // Zero out structure
    servAddr.sin_family = AF_INET;                // Internet address family
    servAddr.sin_addr.s_addr = htonl(INADDR_ANY); // Any incoming interface
    servAddr.sin_port = htons(PORT_ID);      // Local port

    // Create socket for incoming connections
    if ((servSock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
        DieWithError("socket() failed");

    // Bind to the local address
    if (bind(servSock, (struct sockaddr *) &servAddr, sizeof(servAddr)) < 0)
        DieWithError("bind() failed");

	if (gethostname(szBuf, sizeof(szBuf)) < 0)
		DieWithError("gethostname() failed");

	printf("\nTCP Server named %s waiting on port %d\n", szBuf, PORT_ID);

    // Mark the socket so it will listen for incoming connections
    if (listen(servSock, MAXPENDING) < 0)
        DieWithError("listen() failed");

    for (;;) // Run forever
    {
        // Set the fileSize of the in-out parameter
        clntLen = sizeof(echoClntAddr);

        // Wait for connect() from TCP_Client
        if ((clntSock = accept(servSock, (struct sockaddr *) &echoClntAddr, &clntLen)) < 0)
            DieWithError("accept() failed");

        // clntSock is connected to a client!

		///////////////////////////////////////////////////////////////////////////

		// Send received string and receive again until end of transmission
//    	for (nn = 0; ; nn++) // Run forever
		{
			// Receive message from client
			szBuf[0] = '\0';
			if ((recv(clntSock, szBuf, DATASIZE+1, 0)) < 0)
				DieWithError("recv() failed");

			pCh = szBuf;
			// Move pCh after "GET " in "Get / ..."
//			pCh = pCh + 4;				i = 0;
//			while(*pCh != ' ')
			for (pCh += 4, i = 0; *pCh != ' '; pCh++, i++)
			{
				buf[i] = (*pCh=='/') ? '\\' : *pCh;

				if(buf[i] == '.')
					fileExt = 1;
//				pCh++;				i++;
			}

			buf[i] = 0;	// String terminator
			if (strlen(buf)==1)	// Only "/" means default file "index.htm"
//				strcpy(filename, DEFLT_FILE);
				sprintf(filename, "%s\\%s", ROOT_DIR, DEFLT_FILE);
			else
			{
//				strcpy(filename, ROOT_DIR);	// root dir
//				strcat(filename, buf);
				sprintf(filename, "%s\%s", ROOT_DIR, buf);
				if(fileExt==0)
					strcat(filename,"index.html");
			}


			pFile = fopen(filename,"rb");
			fseek(pFile, 0, 2);
			fileSize = ftell(pFile);

			strcpy(szBuf,"HTTP/1.0 200 ok \r\n");

			sprintf(szBuf, "%sContent-Length:%ld\r\n\r\n", szBuf, fileSize);

			lenBuf = strlen(szBuf);
			if (send(clntSock, szBuf, lenBuf, 0) != lenBuf)
				DieWithError("send() header failed");


			pFileBuf = (char *)malloc(fileSize);
			fseek(pFile, 0, 0);
			fread(pFileBuf, fileSize, 1, pFile);

			if (send(clntSock, pFileBuf, fileSize, 0) != fileSize)
				DieWithError("send() file failed");

		}

		closesocket(clntSock);    // Close client socket

    }
    // NOT REACHED
}
