#define	PORT_ID	5000
#define	HOST_ID	"192.168.47.41"

#define		FILE_WR			"tst_w.txt"

//#define		DATASIZE	32
//#define		DATASIZE	1400
//#define		DATASIZE		4095
#define		DATASIZE		0xEFFC


#include <stdio.h>      // for printf(), fprintf()
#include <winsock.h>    // for socket(),...
#include <stdlib.h>     // for exit()

//void DieWithError(char *errorMessage);  // Error handling function

void DieWithError(char *errorMessage)
{
    fprintf(stderr,"%s: %d\n", errorMessage, WSAGetLastError());
    exit(1);
}

//void main(int argc, char *argv[])
void main(void)
{
    int 	sock;                        // Socket descriptor
    struct 	sockaddr_in echoServAddr; // Echo server address
    int 	lenBuf;               // Length of string to echo
    int 	bytesRcvd, totalBytesRcvd;   // Bytes read in single recv() and total bytes read
    WSADATA wsaData;                 // Structure for WinSock setup communication

    char 	szBuf[DATASIZE+1];                // String to send to echo server
	int		i, nn;

	FILE	*fw;
	char	ch;

	DWORD	  dwTimeSent, dwElapsed;

    if (WSAStartup(MAKEWORD(2, 0), &wsaData) != 0) // Load Winsock 2.0 DLL
    {
        fprintf(stderr, "WSAStartup() failed");
        exit(1);
    }

    // Construct the server address structure
    memset(&echoServAddr, 0, sizeof(echoServAddr));     // Zero out structure
    echoServAddr.sin_family      = AF_INET;             // Internet address family
    echoServAddr.sin_addr.s_addr = inet_addr(HOST_ID);   // Server IP address
    echoServAddr.sin_port        = htons(PORT_ID); // Server port

    // Create a reliable, stream socket using TCP
    if ((sock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
        DieWithError("socket() failed");

	printf("\nTCP Client sending to server: %s on port: %d\n", HOST_ID, PORT_ID);

    // Establish the connection to the echo server for accept() in TCP_Server
    if (connect(sock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
        DieWithError("connect() failed");

	///////////////////////////////////////////////////////////////////////////
	if ((fw = fopen(FILE_WR, "w")) == NULL) {
		fprintf(stderr,"\nFail to open %s to write\n", FILE_WR);
		return;
	}

	dwTimeSent = GetTickCount();

//	for (nn = 0; nn < 4; nn++) {
	for (nn = 0; ; nn++) {
		sprintf(szBuf, "From TCP Client %d\n\0", nn);

		lenBuf = strlen(szBuf) + 1;          // Determine input length

		// Send the string, including the null terminator, to the server
		if (send(sock, szBuf, lenBuf, 0) != lenBuf)
			DieWithError("send() sent a different number of bytes than expected");

		// Receive the same string back from the server
		totalBytesRcvd = 0;
//		printf("Received: ");                // Setup to print the echoed string
//		while (totalBytesRcvd < lenBuf)
		{
			// Receive up to the buffer size (minus 1 to leave space for a null terminator) bytes from the sender
			szBuf[0] = '\0';
			if ((bytesRcvd = recv(sock, szBuf, DATASIZE+1, 0)) <= 0)
				DieWithError("recv() failed or connection closed prematurely");
			totalBytesRcvd += bytesRcvd;   // Keep tally of total bytes
//			szBuf[bytesRcvd] = '\0';  // Add \0 so printf knows where to stop
//			printf(szBuf);            // Print the echo buffer

			for(i=0; ((ch = szBuf[i]) != EOF)&& (i<DATASIZE); i++) {
				putc(ch, fw);
			}

			if (ch == EOF)
				break;
		}
	}

	dwElapsed = GetTickCount() - dwTimeSent;
	printf("\n\n>> Time Elapsed %d\n", dwElapsed);
	fprintf(fw, "\n\n>> Time Elapsed %d\n", dwElapsed);

	fclose(fw);

    closesocket(sock);
    WSACleanup();  // Cleanup Winsock

    exit(0);
}
