#define	PORT_ID	5000

//#define		DATASIZE	32
//#define		DATASIZE	1400
//#define		DATASIZE		4095
#define		DATASIZE		0xEFFC

//#define		FILE_RD			"tst_r.txt"
#define		FILE_RD			"e24d1a.rpt"

#include <stdio.h>      // for printf(), fprintf()
#include <winsock.h>    // for socket(),...
#include <stdlib.h>     // for exit()

#define MAXPENDING 5    // Maximum outstanding connection requests

void DieWithError(char *errorMessage)
{
    fprintf(stderr,"%s: %d\n", errorMessage, WSAGetLastError());
    exit(1);
}


//void DieWithError(char *errorMessage);  // Error handling function

//void main(int argc, char *argv[])
void main(void)
{
    int 	servSock;                    // Socket descriptor for server
    int 	clntSock;                    // Socket descriptor for client
    struct 	sockaddr_in echoServAddr; // Local address
    struct 	sockaddr_in echoClntAddr; // Client address
    unsigned int clntLen;            // Length of client address data structure
    WSADATA 	wsaData;                 // Structure for WinSock setup communication

    char 	szBuf[DATASIZE+1];        // Buffer for echo string
    int 	i, nn, lenBuf;                    // Size of received message
	FILE	*fr;
	char	ch;

    if (WSAStartup(MAKEWORD(2, 0), &wsaData) != 0) // Load Winsock 2.0 DLL
    {
        fprintf(stderr, "WSAStartup() failed");
        exit(1);
    }

    // Construct local address structure
    memset(&echoServAddr, 0, sizeof(echoServAddr));   // Zero out structure
    echoServAddr.sin_family = AF_INET;                // Internet address family
    echoServAddr.sin_addr.s_addr = htonl(INADDR_ANY); // Any incoming interface
    echoServAddr.sin_port = htons(PORT_ID);      // Local port

    // Create socket for incoming connections
    if ((servSock = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0)
        DieWithError("socket() failed");

    // Bind to the local address
    if (bind(servSock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
        DieWithError("bind() failed");

	if (gethostname(szBuf, sizeof(szBuf)) < 0)
		DieWithError("gethostname() failed");

	printf("\nTCP Server named %s waiting on port %d\n", szBuf, PORT_ID);

    // Mark the socket so it will listen for incoming connections
    if (listen(servSock, MAXPENDING) < 0)
        DieWithError("listen() failed");

    for (;;) // Run forever
    {
        // Set the size of the in-out parameter
        clntLen = sizeof(echoClntAddr);

        // Wait for connect() from TCP_Client
        if ((clntSock = accept(servSock, (struct sockaddr *) &echoClntAddr, &clntLen)) < 0)
            DieWithError("accept() failed");

        // clntSock is connected to a client!

		///////////////////////////////////////////////////////////////////////////
		if ((fr = fopen(FILE_RD, "r")) == NULL) {
			fprintf(stderr,"\nFail to open %s to read\n", FILE_RD);
			return;
		}

//        HandleTCPClient(clntSock);
		// Send received string and receive again until end of transmission
    	for (nn = 0; ; nn++) // Run forever
		{
			// Receive message from client
			szBuf[0] = '\0';
			if ((lenBuf = recv(clntSock, szBuf, DATASIZE+1, 0)) < 0)
				DieWithError("recv() failed");

			if (lenBuf==0)
				break;

			printf("TCP Client %s: %s", inet_ntoa(echoClntAddr.sin_addr), szBuf);

			// Echo message back to client

			// Send data back to the client
			for (i=0; ((ch=getc(fr)) != EOF) && (i<DATASIZE); i++)                 // Test block is 2x data size
				szBuf[i] = ch;       // ..same data as DOS ping

			if (i < DATASIZE)
				szBuf[i++] = EOF;

			szBuf[i] = '\0';

			// put the last char back to file for next loop
			ungetc(ch, fr);

//			sprintf(szBuf, "Fr TCP Server packet %d\n\0", nn);
			lenBuf = strlen(szBuf) + 1;

			if (send(clntSock, szBuf, lenBuf, 0) != lenBuf)
				DieWithError("send() failed");

		}

		closesocket(clntSock);    // Close client socket

    }
    // NOT REACHED
}
