#define	HOST_ID	"192.168.47.41"

#define	PORT_ID	7	// otherwise, 7 is the well-known port for the echo service

//#define		DATASIZE	32
//#define		DATASIZE	1400
//#define		DATASIZE		4095
#define		DATASIZE		0xEFFC

#define		FILE_WR			"tst_w.txt"

/* CHANGES FROM UNIX VERSION                                                   */
/*                                                                             */
/* 1.  Changed header files.                                                   */
/* 2.  Added WSAStartUP() and WSACleanUp().                                    */
/* 3.  Used closesocket() instead of close().                                  */

#include <stdio.h>      /* for printf(), fprintf() */
#include <winsock.h>    /* for socket(),... */
#include <stdlib.h>     /* for exit() */

//void DieWithError(char *errorMessage);  /* External error handling function */

void DieWithError(char *errorMessage)
{
    fprintf(stderr,"%s: %d\n", errorMessage, WSAGetLastError());
    exit(1);
}

//void main(int argc, char *argv[])
void main(void)
{
    int sock;                        // Socket descriptor
    struct sockaddr_in echoServAddr; // Echo server address
    struct sockaddr_in fromAddr;     // Source address of echo
    unsigned int fromSize;           // In-out of address size for recvfrom()
    int lenBuf;               // Length of string to echo
    WSADATA wsaData;                 // Structure for WinSock setup communication

    char szBuf[DATASIZE+1];        // Buffer for echo string

	FILE	*fw;
	char	ch;

	int		i, nn;

	DWORD	  dwTimeSent, dwElapsed;

    if (WSAStartup(MAKEWORD(2, 0), &wsaData) != 0) // Load Winsock 2.0 DLL
    {
        fprintf(stderr, "WSAStartup() failed");
        exit(1);
    }

    // Construct the server address structure
    memset(&echoServAddr, 0, sizeof(echoServAddr));    // Zero out structure
    echoServAddr.sin_family = AF_INET;                 // Internet address family
    echoServAddr.sin_addr.s_addr = inet_addr(HOST_ID);  // Server IP address
    echoServAddr.sin_port   = htons(PORT_ID);     // Server port

    // Create a best-effort datagram socket using UDP
    if ((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
        DieWithError("socket() failed");

	printf("\nUDP Client sending to server: %s on port: %d\n", HOST_ID, PORT_ID);

	///////////////////////////////////////////////////////////////////////////
	if ((fw = fopen(FILE_WR, "w")) == NULL) {
		fprintf(stderr,"\nFail to open %s to write\n", FILE_WR);
		return;
	}

	dwTimeSent = GetTickCount();

//	for (nn = 0; nn < 4; nn++) {
	for (nn = 0; ; nn++) {
		sprintf(szBuf, "From UDP Client %d\n\0", nn);

		lenBuf = strlen(szBuf) + 1;

		// Send the string, including the null terminator, to the server
		if (sendto(sock, szBuf, lenBuf, 0, (struct sockaddr *)
				   &echoServAddr, sizeof(echoServAddr)) != lenBuf)
			DieWithError("sendto() sent a different number of bytes than expected");

		// Recv a response
		fromSize = sizeof(fromAddr);
		szBuf[0] = '\0';
		if ((recvfrom(sock, szBuf, DATASIZE+1, 0, (struct sockaddr *) &fromAddr,
					 &fromSize)) < 0)
			DieWithError("recvfrom() failed");

		if (echoServAddr.sin_addr.s_addr != fromAddr.sin_addr.s_addr)
		{
			fprintf(stderr,"Error: received a packet from unknown source.\n");
			exit(1);
		}

		for(i=0; ((ch = szBuf[i]) != EOF)&& (i<DATASIZE); i++) {
			putc(ch, fw);
		}

		if (ch == EOF)	break;

	}

	dwElapsed = GetTickCount() - dwTimeSent;
	printf("\n\n>> Time Elapsed %d\n", dwElapsed);
	fprintf(fw, "\n\n>> Time Elapsed %d\n", dwElapsed);

	fclose(fw);

    closesocket(sock);
    WSACleanup();  // Cleanup Winsock

    exit(0);
}
