#define	PORT_ID	7	// otherwise, 7 is the well-known port for the echo service

//#define		DATASIZE	32
//#define		DATASIZE	1400
//#define		DATASIZE		4095
#define		DATASIZE		0xEFFC

//#define		FILE_RD			"tst_r.txt"
#define		FILE_RD			"e24d1a.rpt"

/* CHANGES FROM UNIX VERSION                                                   */
/*                                                                             */
/* 1.  Changed header files.                                                   */
/* 2.  Added WSAStartUP().                                                     */

#include <stdio.h>      // for printf(), fprintf()
#include <winsock.h>    // for socket(),...
#include <stdlib.h>     // for exit()

void DieWithError(char *errorMessage)
{
    fprintf(stderr,"%s: %d\n", errorMessage, WSAGetLastError());
    exit(1);
}

//void main(int argc, char *argv[])
void main(void)
{
    int sock;                        // Socket
    struct sockaddr_in echoServAddr; // Local address
    struct sockaddr_in echoClntAddr; // Client address
    int cliLen;                      // Length of incoming message
    int recvMsgSize;                 // Size of received message
    WSADATA wsaData;                 // Structure for WinSock setup communication

    char szBuf[DATASIZE+1];        // Buffer for echo string

    int		nn, lenBuf;
	FILE	*fr;
	char	ch;
	int		i;

    if (WSAStartup(MAKEWORD(2, 0), &wsaData) != 0) // Load Winsock 2.0 DLL
    {
        fprintf(stderr, "WSAStartup() failed");
        exit(1);
    }

    // Construct local address structure
    memset(&echoServAddr, 0, sizeof(echoServAddr));   // Zero out structure
    echoServAddr.sin_family = AF_INET;                // Internet address family
    echoServAddr.sin_addr.s_addr = htonl(INADDR_ANY); // Any incoming interface
    echoServAddr.sin_port = htons(PORT_ID);      // Local port

    // Create socket for sending/receiving datagrams
    if ((sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP)) < 0)
        DieWithError("socket() failed");

    // Bind to the local address
//    if (bind(sock, (struct sockaddr *) &echoServAddr, sizeof(echoServAddr)) < 0)
//        DieWithError("bind() failed");

	if (gethostname(szBuf, sizeof(szBuf)) < 0)
		DieWithError("gethostname() failed");

	printf("\nUDP Server named %s waiting on port %d\n", szBuf, PORT_ID);

	///////////////////////////////////////////////////////////////////////////
	if ((fr = fopen(FILE_RD, "r")) == NULL) {
		fprintf(stderr,"\nFail to open %s to read\n", FILE_RD);
		return;
	}

    for (nn=0; ; nn++) // Run forever
    {
        // Set the size of the in-out parameter
        cliLen = sizeof(echoClntAddr);

        // Block until receive message from a client
        szBuf[0] = '\0';
        if ((recvMsgSize = recvfrom(sock, szBuf, DATASIZE+1, 0,
            (struct sockaddr *) &echoClntAddr, &cliLen)) < 0)
            DieWithError("recvfrom() failed");

        printf("UDP Client %s: %s", inet_ntoa(echoClntAddr.sin_addr), szBuf);

		// Send data back to the client
		for (i=0; ((ch=getc(fr)) != EOF) && (i<DATASIZE); i++)                 // Test block is 2x data size
			szBuf[i] = ch;       // ..same data as DOS ping

		if (i < DATASIZE)
			szBuf[i++] = EOF;

		szBuf[i] = '\0';

		// put the last char back to file for next loop
		ungetc(ch, fr);

		lenBuf = strlen(szBuf) + 1;

         // Send received datagram back to the client
         if (sendto(sock, szBuf, lenBuf, 0, (struct sockaddr *) &echoClntAddr,
                     sizeof(echoClntAddr)) != lenBuf)
             DieWithError("sendto() sent a different number of bytes than expected");
    }
    // NOT REACHED
}
